diff -uNr mythtv-0.21/libs/libmythtv/eithelper.cpp mythtv/libs/libmythtv/eithelper.cpp
--- mythtv-0.21/libs/libmythtv/eithelper.cpp	2008-03-04 00:05:20.000000000 +0100
+++ mythtv/libs/libmythtv/eithelper.cpp	2009-05-05 21:57:19.000000000 +0200
@@ -393,7 +393,9 @@
         }
 
         QDateTime starttime = MythUTCToLocal(eit->StartTimeUTC(i));
-        EITFixUp::TimeFix(starttime);
+        // fix starttime only if the duration is a multiple of a minute
+        if (!(eit->DurationInSeconds(i) % 60))
+            EITFixUp::TimeFix(starttime);
         QDateTime endtime   = starttime.addSecs(eit->DurationInSeconds(i));
 
         DBEvent *event = new DBEvent(chanid,
@@ -495,7 +497,9 @@
         for (uint k=0; k<transmission.TransmissionCount(); ++k)
         {
             QDateTime starttime = transmission.StartTimeUTC(k);
-            EITFixUp::TimeFix(starttime);
+            // fix starttime only if the duration is a multiple of a minute
+            if (!(cit->DurationInSeconds() % 60))
+                EITFixUp::TimeFix(starttime);
             QDateTime endtime   = starttime.addSecs(cit->DurationInSeconds());
 
             DBEvent *event = new DBEvent(chanid,
@@ -551,7 +555,9 @@
         starttime.setTime_t(tmp - utc_offset, Qt::LocalTime);
     }
 
-    EITFixUp::TimeFix(starttime);
+    // fix starttime only if the duration is a multiple of a minute
+    if (!(event.length % 60))
+        EITFixUp::TimeFix(starttime);
     QDateTime endtime = starttime.addSecs(event.length);
 
     desc_list_t list = MPEGDescriptor::Parse(event.desc, event.desc_length);
@@ -693,6 +699,20 @@
 
     // United Kingdom
     fix[ 9018U << 16] = EITFixUp::kFixUK;
+    // UK Freesat
+    fix[ 2013LL << 32 | 2U << 16] = EITFixUp::kFixUK;
+    fix[ 2041LL << 32 | 2U << 16] = EITFixUp::kFixUK;
+    fix[ 2042LL << 32 | 2U << 16] = EITFixUp::kFixUK;
+    fix[ 2044LL << 32 | 2U << 16] = EITFixUp::kFixUK;
+    fix[ 2045LL << 32 | 2U << 16] = EITFixUp::kFixUK;
+    fix[ 2046LL << 32 | 2U << 16] = EITFixUp::kFixUK;
+    fix[ 2047LL << 32 | 2U << 16] = EITFixUp::kFixUK;
+    fix[ 2048LL << 32 | 2U << 16] = EITFixUp::kFixUK;
+    fix[ 2049LL << 32 | 2U << 16] = EITFixUp::kFixUK;
+    fix[ 2050LL << 32 | 2U << 16] = EITFixUp::kFixUK;
+    fix[ 2051LL << 32 | 2U << 16] = EITFixUp::kFixUK;
+    fix[ 2053LL << 32 | 2U << 16] = EITFixUp::kFixUK;
+    fix[ 2054LL << 32 | 2U << 16] = EITFixUp::kFixUK;
 
     // ComHem Sweeden
     fix[40999U << 16       ] = EITFixUp::kFixComHem;
@@ -814,20 +834,24 @@
         EITFixUp::kEFixForceISO8859_15;
     // On transport 10008 only following channels need fixing:
     fix[    10008LL<<32 | 61441U << 16 | 53002] = // Tele 5
-        fix[10008LL<<32 | 61441U << 16 | 53630] = // HSE24
         EITFixUp::kEFixForceISO8859_15;
 
     // DVB-S Astra 19.2E DMAX Germany
     fix[  1113LL << 32 | 1 << 16 | 12602] = EITFixUp::kEFixForceISO8859_15;
 
-    // Premiere and Pro7/Sat.1
+    // Premiere
     fix[133 << 16] = EITFixUp::kEFixForceISO8859_15;
 
-    // DVB-T Spain
-    fix[       10LL << 32 | 8916 << 16 ] = // national multiplex
-        fix[   12LL << 32 | 8916 << 16 ] = // national multiplex
-        fix[   13LL << 32 | 8916 << 16 ] = // national multiplex
-        fix[ 6200LL << 32 | 8916 << 16 ] = // Madrid (TeleMadrid)
+    // DVB-S Astra 19.2E french channels
+    fix[     1022LL << 32 | 1 << 16 |  6901 ] = // DIRECT 8
+        fix[ 1022LL << 32 | 1 << 16 |  6905 ] = // France 24 (en Francais)
+        fix[ 1022LL << 32 | 1 << 16 |  6911 ] = // DIRECT 8
+        fix[ 1072LL << 32 | 1 << 16 |  8201 ] = // CANAL+
+        fix[ 1070LL << 32 | 1 << 16 |  8004 ] = // EURONEWS
+        fix[ 1091LL << 32 | 1 << 16 | 31220 ] = // EuroNews
+        fix[ 1094LL << 32 | 1 << 16 | 17027 ] = // LCP
+        fix[ 1094LL << 32 | 1 << 16 | 17028 ] = // NT1
+        fix[ 1100LL << 32 | 1 << 16 |  8710 ] = // NRJ 12
         EITFixUp::kEFixForceISO8859_15;
 }
 
diff -uNr mythtv-0.21/libs/libmythtv/filtermanager.cpp mythtv/libs/libmythtv/filtermanager.cpp
--- mythtv-0.21/libs/libmythtv/filtermanager.cpp	2008-02-22 19:24:44.000000000 +0100
+++ mythtv/libs/libmythtv/filtermanager.cpp	2008-11-19 08:16:08.000000000 +0100
@@ -89,6 +89,9 @@
                 LoadFilterLib(Path);
         }
     }
+    else
+        VERBOSE(VB_IMPORTANT,
+                "Filter dir '" + FiltDir.absPath() + "' doesn't exist?");
 }
 
 FilterManager::~FilterManager()
diff -uNr mythtv-0.21/libs/libmythtv/firewiredevice.cpp mythtv/libs/libmythtv/firewiredevice.cpp
--- mythtv-0.21/libs/libmythtv/firewiredevice.cpp	2008-03-04 18:43:47.000000000 +0100
+++ mythtv/libs/libmythtv/firewiredevice.cpp	2009-04-25 05:52:16.000000000 +0200
@@ -224,8 +224,11 @@
         return true;
     }
 
+    // the PACE is obviously not a Motorola channel changer, but the
+    // same commands work for it as the Motorola.
     bool is_mot = ((panel_model.upper().left(4) == "DCT-") ||
-                   (panel_model.upper().left(4) == "DCH-"));
+                   (panel_model.upper().left(4) == "DCH-") ||
+                   (panel_model.upper().left(4) == "PACE-"));
 
     if (is_mot && !alt_method)
     {
@@ -235,7 +238,7 @@
             cmd.push_back(kAVCControlCommand);
             cmd.push_back(kAVCSubunitTypePanel | m_subunitid);
             cmd.push_back(kAVCPanelPassThrough);
-            cmd.push_back(kAVCPanelKey0 + digit[i] | kAVCPanelKeyPress);
+            cmd.push_back((kAVCPanelKey0 + digit[i]) | kAVCPanelKeyPress);
             cmd.push_back(0x00);
             cmd.push_back(0x00);
             cmd.push_back(0x00);
@@ -399,8 +402,9 @@
 
     const uint64_t sa_vendor_ids[] =
     {
-        0x11e6,    0x14f8,    0x1692,    0x1947,    0x0f21,    0x1ac3,
-        0x0a73,
+        0x0a73,    0x0f21,    0x11e6,    0x14f8,    0x1692,    0x1868,
+        0x1947,    0x1ac3,    0x1bd7,    0x1cea,    0x1e6b,    0x21be,
+        0x223a,    0x22ce,    0x23be,    0x252e,
     };
     const uint sa_vendor_id_cnt =
         sizeof(sa_vendor_ids) / sizeof(uint64_t);
@@ -415,19 +419,29 @@
     const uint64_t motorola_vendor_ids[] =
     {
         /* DCH-3200 */
-        0x1c11,
-        /* 3416 */
+        0x1c11,    0x1cfb,    0x1fc4,    0x23a3,
+        /* DCH-3416 */
+        0x1e46,
+        /* DCT-3416 */
         0x1bdd,
-        /* 3412 */
+        /* DCT-3412 */
         0x159a,
-        /* 6200, 3416 */
+        /* DCT-6200, DCT-3416 */
         0x0ce5,    0x0e5c,    0x1225,    0x0f9f,    0x1180,
         0x12c9,    0x11ae,    0x152f,    0x14e8,    0x16b5,    0x1371,
-        0x19a6,    0x1aad,    0x0b06,    0x195e,
-        /* 6212 */
+        0x19a6,    0x1aad,    0x0b06,    0x195e,    0x10dc,
+        /* DCT-6212 */
         0x0f9f,    0x152f,
-        /* 6216, 2224 */
+        /* DCT-6216, 2224 */
         0x17ee,    0x1a66,
+        /* QIP 7100 */
+        0x2374,
+        /* unknown, see http://standards.ieee.org/regauth/oui/oui.txt */
+        0x04db,    0x0406,    0x0ce5,    0x111a,    0x1225,    0x1404,
+        0x1626,    0x18c0,    0x1ade,    0x1cfb,    0x2040,    0x211e,
+        0x2180,    0x2210,    0x230b,    0x2375,    0x2395,    0x23a2,
+        0x23ed,    0x23ee,    0x23a0,    0x23a1,
+
     };
     const uint motorola_vendor_id_cnt =
         sizeof(motorola_vendor_ids) / sizeof(uint64_t);
@@ -435,6 +449,7 @@
     for (uint i = 0; i < motorola_vendor_id_cnt; i++)
     {
         id_to_model[motorola_vendor_ids[i] << 32 | 0xd330] = "DCH-3200";
+        id_to_model[motorola_vendor_ids[i] << 32 | 0xb630] = "DCH-3416";
         id_to_model[motorola_vendor_ids[i] << 32 | 0x34cb] = "DCT-3412";
         id_to_model[motorola_vendor_ids[i] << 32 | 0x346b] = "DCT-3416";
         id_to_model[motorola_vendor_ids[i] << 32 | 0xb630] = "DCT-3416";
@@ -443,6 +458,23 @@
         id_to_model[motorola_vendor_ids[i] << 32 | 0x64ca] = "DCT-6212";
         id_to_model[motorola_vendor_ids[i] << 32 | 0x64cb] = "DCT-6212";
         id_to_model[motorola_vendor_ids[i] << 32 | 0x646b] = "DCT-6216";
+        id_to_model[motorola_vendor_ids[i] << 32 | 0x8100] = "QIP-7100";
+        id_to_model[motorola_vendor_ids[i] << 32 | 0x0001] = "QIP-7100";
+    }
+
+    const uint64_t pace_vendor_ids[] =
+    {
+        /* PACE 550-HD & 779 */
+        0x1cc3, 0x5094,
+    };
+
+    const uint pace_vendor_id_cnt =
+        sizeof(pace_vendor_ids) / sizeof(uint64_t);
+
+    for (uint i = 0; i < pace_vendor_id_cnt; i++)
+    {
+        id_to_model[pace_vendor_ids[i] << 32 | 0x10551] = "PACE-550";
+        id_to_model[pace_vendor_ids[i] << 32 | 0x10755] = "PACE-779";
     }
 }
 
@@ -450,6 +482,7 @@
 {
     QString model = panel_model.upper();
     return ((model == "DCH-3200") ||
+            (model == "DCH-3416") ||
             (model == "DCT-3412") ||
             (model == "DCT-3416") ||
             (model == "DCT-6200") ||
@@ -458,6 +491,9 @@
             (model == "SA3250HD") ||
             (model == "SA4200HD") ||
             (model == "SA4250HDC") ||
+            (model == "PACE-550") ||
+            (model == "PACE-779") ||
+            (model == "QIP-7100") ||
             (model == "GENERIC"));
 }
 
diff -uNr mythtv-0.21/libs/libmythtv/frequencytables.cpp mythtv/libs/libmythtv/frequencytables.cpp
--- mythtv-0.21/libs/libmythtv/frequencytables.cpp	2007-12-11 15:56:01.000000000 +0100
+++ mythtv/libs/libmythtv/frequencytables.cpp	2008-09-27 15:54:35.000000000 +0200
@@ -320,6 +320,24 @@
         DTVGuardInterval::kGuardIntervalAuto, DTVHierarchy::kHierarchyNone,
         DTVModulation::kModulationQAMAuto, 125000, 0); // UHF 21-69
 
+    // New Zealand
+    fmap["dvbt_ofdm_nz0"] = new FrequencyTable(
+        474000000, 858000000, 8000000, "", 0, DTVInversion::kInversionOff,
+        DTVBandwidth::kBandwidth8MHz, DTVCodeRate::kFEC_3_4,
+        DTVCodeRate::kFEC_3_4, DTVModulation::kModulationQAM64,
+        DTVTransmitMode::kTransmissionMode8K,
+        DTVGuardInterval::kGuardInterval_1_16, DTVHierarchy::kHierarchyNone,
+        DTVModulation::kModulationQAM64, 0 , 0); // UHF 21-69
+
+    // france
+    fmap["dvbt_ofdm_fr0"] = new FrequencyTable(
+        474000000, 850000000, 8000000, "" , 0, DTVInversion::kInversionOff,
+        DTVBandwidth::kBandwidth8MHz, DTVCodeRate::kFECAuto,
+        DTVCodeRate::kFECAuto, DTVModulation::kModulationQAMAuto,
+        DTVTransmitMode::kTransmissionMode8K,
+        DTVGuardInterval::kGuardIntervalAuto, DTVHierarchy::kHierarchyNone,
+        DTVModulation::kModulationQAMAuto, 167000, -166000);
+    
 //#define DEBUG_DVB_OFFSETS
 #ifdef DEBUG_DVB_OFFSETS
     // UHF 14-69
diff -uNr mythtv-0.21/libs/libmythtv/hdhrchannel.cpp mythtv/libs/libmythtv/hdhrchannel.cpp
--- mythtv-0.21/libs/libmythtv/hdhrchannel.cpp	2008-01-14 17:45:33.000000000 +0100
+++ mythtv/libs/libmythtv/hdhrchannel.cpp	2009-03-18 13:34:58.000000000 +0100
@@ -1,6 +1,6 @@
 /**
- *  DBox2Channel
- *  Copyright (c) 2006 by Silicondust Engineering Ltd.
+ *  HDHRChannel
+ *  Copyright (c) 2006-2009 by Silicondust Engineering Ltd.
  *  Distributed as part of MythTV under GPL v2 and later.
  */
 
@@ -24,7 +24,6 @@
 #include "hdhrchannel.h"
 #include "videosource.h"
 #include "channelutil.h"
-#include "frequencytables.h"
 
 #define DEBUG_PID_FILTERS
 
@@ -391,22 +390,27 @@
 bool HDHRChannel::Tune(uint frequency, QString /*input*/,
                        QString modulation, QString si_std)
 {
-    bool ok = false;
+    // Convert dtv_multiplex.modulation strings to something the HDHR can use:
+    modulation.replace("qam_", "qam");  // e.g. qam_256 -> qam256
+#if 0
+    if (modulation == "qamauto")
+        modulation = "qam";             // "auto" works just as well?
+#endif
 
-    VERBOSE(VB_CHANNEL, LOC +
-            QString("TuneTo(%1,%2)").arg(frequency).arg(modulation));
+    if (modulation.isEmpty())
+        modulation = "auto";
 
-    if (modulation == "8vsb")
-        ok = TunerSet("channel", QString("8vsb:%1").arg(frequency));
-    else if (modulation == "qam_64")
-        ok = TunerSet("channel", QString("qam64:%1").arg(frequency));
-    else if (modulation == "qam_256")
-        ok = TunerSet("channel", QString("qam256:%1").arg(frequency));
+    QString chan = modulation + ':' + QString::number(frequency);
 
-    if (ok)
+    VERBOSE(VB_CHANNEL, LOC + "Tune()ing to " + chan);
+
+    if (TunerSet("channel", chan).length())
+    {
         SetSIStandard(si_std);
+        return true;
+    }
 
-    return ok;
+    return false;
 }
 
 bool HDHRChannel::AddPID(uint pid, bool do_update)
diff -uNr mythtv-0.21/libs/libmythtv/hdhrrecorder.cpp mythtv/libs/libmythtv/hdhrrecorder.cpp
--- mythtv-0.21/libs/libmythtv/hdhrrecorder.cpp	2008-01-14 17:45:33.000000000 +0100
+++ mythtv/libs/libmythtv/hdhrrecorder.cpp	2009-03-02 15:24:15.000000000 +0100
@@ -1,6 +1,6 @@
 /** -*- Mode: c++ -*-
  *  HDHRRecorder
- *  Copyright (c) 2006 by Silicondust Engineering Ltd, and
+ *  Copyright (c) 2006-2009 by Silicondust Engineering Ltd, and
  *    Daniel Thor Kristjansson
  *  Distributed as part of MythTV under GPL v2 and later.
  */
@@ -27,6 +27,7 @@
 #include "hdhrrecorder.h"
 #include "atsctables.h"
 #include "atscstreamdata.h"
+#include "dvbstreamdata.h"
 #include "eithelper.h"
 #include "tv_rec.h"
 
@@ -176,10 +177,13 @@
         data->AddMPEGListener(this);
 
         ATSCStreamData *atsc = dynamic_cast<ATSCStreamData*>(data);
+        DVBStreamData  *dvb  = dynamic_cast<DVBStreamData*>(data);
 
         if (atsc && atsc->DesiredMinorChannel())
             atsc->SetDesiredChannel(atsc->DesiredMajorChannel(),
                                     atsc->DesiredMinorChannel());
+        else if (dvb)
+            dvb->AddDVBMainListener(this);
         else if (data->DesiredProgram() >= 0)
             data->SetDesiredProgram(data->DesiredProgram());
     }
@@ -250,9 +254,13 @@
     if (!pmt)
         return;
 
-    int next = (pmt->tsheader()->ContinuityCounter()+1)&0xf;
-    pmt->tsheader()->SetContinuityCounter(next);
-    BufferedWrite(*(reinterpret_cast<TSPacket*>(pmt->tsheader())));
+    unsigned char buf[8 * 1024];
+    uint next_cc = (pmt->tsheader()->ContinuityCounter()+1)&0xf;
+    pmt->tsheader()->SetContinuityCounter(next_cc);
+    uint size = pmt->WriteAsTSPackets(buf, next_cc);
+
+    for (uint i = 0; i < size ; i += TSPacket::SIZE)
+        DTVRecorder::BufferedWrite(*(reinterpret_cast<TSPacket*>(&buf[i])));
 }
 
 /** \fn HDHRRecorder::HandleMGT(const MasterGuideTable*)
diff -uNr mythtv-0.21/libs/libmythtv/hdhrrecorder.h mythtv/libs/libmythtv/hdhrrecorder.h
--- mythtv-0.21/libs/libmythtv/hdhrrecorder.h	2007-01-10 17:29:26.000000000 +0100
+++ mythtv/libs/libmythtv/hdhrrecorder.h	2009-03-02 15:24:15.000000000 +0100
@@ -1,6 +1,6 @@
 /** -*- Mode: c++ -*-
  *  HDHRRecorder
- *  Copyright (c) 2006 by Silicondust Engineering Ltd.
+ *  Copyright (c) 2006-2009 by Silicondust Engineering Ltd.
  *  Distributed as part of MythTV under GPL v2 and later.
  */
 
@@ -18,11 +18,11 @@
 typedef vector<uint>        uint_vec_t;
 
 class HDHRRecorder : public DTVRecorder,
+                     public DVBMainStreamListener,
+                     public ATSCMainStreamListener,
                      public MPEGStreamListener,
                      public MPEGSingleProgramStreamListener
 {
-    friend class ATSCStreamData;
-
   public:
     HDHRRecorder(TVRec *rec, HDHRChannel *channel);
     ~HDHRRecorder();
@@ -52,12 +52,15 @@
     void HandleSingleProgramPAT(ProgramAssociationTable *pat);
     void HandleSingleProgramPMT(ProgramMapTable *pmt);
 
-    /*
     // ATSC
     void HandleSTT(const SystemTimeTable*) {}
-    void HandleMGT(const MasterGuideTable *mgt);
+    void HandleMGT(const MasterGuideTable *) {};
     void HandleVCT(uint, const VirtualChannelTable*) {}
-    */
+
+    // DVB
+    void HandleTDT(const TimeDateTable*) {}
+    void HandleNIT(const NetworkInformationTable*) {}
+    void HandleSDT(uint /*tsid*/, const ServiceDescriptionTable*) {}
 
   private:
     bool AdjustFilters(void);
diff -uNr mythtv-0.21/libs/libmythtv/importicons.cpp mythtv/libs/libmythtv/importicons.cpp
--- mythtv-0.21/libs/libmythtv/importicons.cpp	2008-01-29 00:31:10.000000000 +0100
+++ mythtv/libs/libmythtv/importicons.cpp	2008-05-28 02:19:25.000000000 +0200
@@ -123,9 +123,9 @@
     {
         case STATE_NORMAL:
             if (m_editManual->getValue())
-                 m_buttonManual->setEnabled(true);
+                m_buttonManual->setEnabled(true);
             else
-            m_buttonManual->setEnabled(false);
+                m_buttonManual->setEnabled(false);
             if (m_missingCount < m_missingMaxCount)
             {
                 if (m_missingMaxCount < 2) //When there's only one icon, nothing to skip to!
@@ -210,7 +210,7 @@
                             arg(escape_csv(entry2.strServiceId));
 
     if ((!isBlocked(m_strMatches)) &&
-            (checkAndDownload(entry.strLogo)))
+            (checkAndDownload(entry.strLogo, entry2.strChanId)))
     {
 
         if (m_missingMaxCount > 1)
@@ -453,7 +453,7 @@
     return str;
 }
 
-bool ImportIconsWizard::checkAndDownload(const QString& str)
+bool ImportIconsWizard::checkAndDownload(const QString& str, const QString& localChanId)
 {
     // Do not try and access dialog within this function
 
@@ -481,7 +481,7 @@
 
         query.prepare(qstr);
         query.bindValue(":ICON", m_strChannelDir+str2);
-        query.bindValue(":CHANID", (*m_iter).strChanId);
+        query.bindValue(":CHANID", localChanId);
 
         if (!query.exec())
         {
@@ -572,6 +572,9 @@
         VERBOSE(VB_CHANNEL, QString("Icon Import: Working search : %1").arg(str));
         QStringList strSplit=QStringList::split("\n",str);
 
+        QString prevIconName = "";
+        int namei = 1;
+
         for (QStringList::iterator begin=strSplit.begin();
              begin!=strSplit.end();begin++)
         {
@@ -584,7 +587,19 @@
                 entry.strName=ret[1];
                 entry.strLogo=ret[2];
                 m_listSearch.append(entry);
-                m_listIcons->addSelection(entry.strName);
+                if (prevIconName == entry.strName)
+                {
+                    QString newname = QString("%1 (%2)").arg(entry.strName)
+                                                        .arg(namei);
+                    m_listIcons->addSelection(newname);
+                    namei++;
+                }
+                else
+                {
+                    m_listIcons->addSelection(entry.strName);
+                    namei=1;
+                }
+                prevIconName = entry.strName;
             }
         }
         retVal=true;
@@ -617,7 +632,7 @@
             {
                 QStringList ret = extract_csv(*begin);
                 VERBOSE(VB_CHANNEL, QString("Icon Import: findmissing : %1 %2 %3 %4 %5").arg(ret[0]).arg(ret[1]).arg(ret[2]).arg(ret[3]).arg(ret[4]));
-                checkAndDownload(ret[4]);
+                checkAndDownload(ret[4], (*m_iter).strChanId);
             }
         }
         return true;
diff -uNr mythtv-0.21/libs/libmythtv/importicons.h mythtv/libs/libmythtv/importicons.h
--- mythtv-0.21/libs/libmythtv/importicons.h	2008-01-03 21:00:00.000000000 +0100
+++ mythtv/libs/libmythtv/importicons.h	2008-05-20 13:00:46.000000000 +0200
@@ -145,9 +145,10 @@
     /*! \brief checks and attempts to download the logo file to the appropriate
      *   place
      * \param str the string of the downloaded url
+     * \param localChanId the local ID number of the channel
      * \return true/false
      */
-    bool checkAndDownload(const QString& str);
+    bool checkAndDownload(const QString& str, const QString& localChanId);
 
     /*! \brief attempt the inital load of the TV channel information
      * \return the number of TV channels
diff -uNr mythtv-0.21/libs/libmythtv/inputinfo.cpp mythtv/libs/libmythtv/inputinfo.cpp
--- mythtv-0.21/libs/libmythtv/inputinfo.cpp	2008-01-14 16:22:34.000000000 +0100
+++ mythtv/libs/libmythtv/inputinfo.cpp	2008-05-04 20:33:20.000000000 +0200
@@ -46,6 +46,9 @@
 bool InputInfo::FromStringList(QStringList::const_iterator &it,
                                QStringList::const_iterator end)
 {
+    if (it == end)
+        return false;
+
     name     = QDeepCopy<QString>(*it);
     name     = (name == "<EMPTY>") ? QString::null : name;
     NEXT();
diff -uNr mythtv-0.21/libs/libmythtv/iptv/iptvfeederudp.cpp mythtv/libs/libmythtv/iptv/iptvfeederudp.cpp
--- mythtv-0.21/libs/libmythtv/iptv/iptvfeederudp.cpp	2007-11-12 15:23:13.000000000 +0100
+++ mythtv/libs/libmythtv/iptv/iptvfeederudp.cpp	2008-11-05 01:58:33.000000000 +0100
@@ -70,6 +70,8 @@
     if (!InitEnv())
         return false;
     
+    ReceivingSocketAddr = our_inet_addr(parse.host().latin1());
+
     Groupsock *socket = new Groupsock(*_live_env, addr, parse.port(), 0);
     if (!socket)
     {
diff -uNr mythtv-0.21/libs/libmythtv/jobqueue.cpp mythtv/libs/libmythtv/jobqueue.cpp
--- mythtv-0.21/libs/libmythtv/jobqueue.cpp	2007-12-11 15:56:01.000000000 +0100
+++ mythtv/libs/libmythtv/jobqueue.cpp	2008-04-04 13:40:43.000000000 +0200
@@ -1249,7 +1249,7 @@
                       "j.args, j.comment, r.endtime, j.schedruntime "
                   "FROM jobqueue j, recorded r "
                   "WHERE j.chanid = r.chanid AND j.starttime = r.starttime "
-                  "ORDER BY j.inserttime, j.chanid, j.id;");
+                  "ORDER BY j.schedruntime, j.id;");
 
     if (!query.exec() || !query.isActive())
     {
diff -uNr mythtv-0.21/libs/libmythtv/jobqueue.h mythtv/libs/libmythtv/jobqueue.h
--- mythtv-0.21/libs/libmythtv/jobqueue.h	2007-12-03 07:07:52.000000000 +0100
+++ mythtv/libs/libmythtv/jobqueue.h	2008-07-12 04:18:55.000000000 +0200
@@ -108,7 +108,7 @@
                          QDateTime starttime, QString args = "",
                          QString comment = "", QString host = "",
                          int flags = 0, int status = JOB_QUEUED,
-                         QDateTime schedruntime = QDateTime::QDateTime());
+                         QDateTime schedruntime = QDateTime());
 
     static bool QueueJobs(int jobTypes, QString chanid,
                          QDateTime starttime, QString args = "",
diff -uNr mythtv-0.21/libs/libmythtv/libmythtv.pro mythtv/libs/libmythtv/libmythtv.pro
--- mythtv-0.21/libs/libmythtv/libmythtv.pro	2008-02-18 23:59:32.000000000 +0100
+++ mythtv/libs/libmythtv/libmythtv.pro	2008-07-01 17:03:29.000000000 +0200
@@ -185,6 +185,7 @@
 HEADERS += mpeg/dvbdescriptors.h    mpeg/dishdescriptors.h
 HEADERS += mpeg/premieredescriptors.h
 HEADERS += mpeg/atsc_huffman.h      mpeg/iso639.h
+HEADERS += mpeg/freesat_huffman.h   mpeg/freesat_tables.h
 HEADERS += mpeg/iso6937tables.h
 HEADERS += mpeg/tsstats.h           mpeg/streamlisteners.h
 HEADERS += mpeg/h264utils.h
@@ -198,6 +199,7 @@
 SOURCES += mpeg/dvbdescriptors.cpp  mpeg/dishdescriptors.cpp
 SOURCES += mpeg/premieredescriptors.cpp
 SOURCES += mpeg/atsc_huffman.cpp    mpeg/iso639.cpp
+SOURCES += mpeg/freesat_huffman.cpp
 SOURCES += mpeg/iso6937tables.cpp
 SOURCES += mpeg/h264utils.cpp
 
@@ -312,6 +314,8 @@
     using_opengl_video:HEADERS += openglvideo.h
     using_opengl_video:SOURCES += openglvideo.cpp
 
+    using_glx_proc_addr_arb:DEFINES += USING_GLX_PROC_ADDR_ARB
+
     # Misc. frontend
     HEADERS += guidegrid.h              infostructs.h
     HEADERS += progfind.h               ttfont.h
@@ -499,6 +503,9 @@
 }
 
 mingw {
+    # For easier debugging: 
+    target.path = $${PREFIX}/bin
+
     DEFINES -= USING_OPENGL_VSYNC
     DEFINES += USING_D3D
 
@@ -515,3 +522,23 @@
 inc.files = programinfo.h remoteutil.h recordingtypes.h
 
 INSTALLS += inc
+
+unix {
+    SOURCES-=dbcheck.cpp
+    OBJECTS+=dbcheck.o
+    gcc431_workaround.target=dbcheck.o
+    gcc431_workaround.commands=$(CXX) -c $(CXXFLAGS) -O0 $(INCPATH) -o dbcheck.o dbcheck.cpp
+    gcc431_workaround.depends=dbcheck.h dbcheck.cpp
+    gcc431_workaround.depends+=datadirect.h videodisplayprofile.h
+    gcc431_workaround.depends+=../libmyth/mythcontext.h
+    gcc431_workaround.depends+=../libmyth/mythdbcon.h
+    gcc431_workaround.depends+=../libmyth/dbutil.h
+    gcc431_workaround.depends+=../libmyth/mythexp.h
+    gcc431_workaround.depends+=../libmyth/mythobservable.h
+    gcc431_workaround.depends+=../libmyth/mythsocket.h
+    gcc431_workaround.depends+=../libmyth/mythverbose.h
+    gcc431_workaround.depends+=../libmyth/mythevent.h
+    QMAKE_EXTRA_UNIX_TARGETS+=gcc431_workaround
+}
+
+include ( ../libs-targetfix.pro )
